101            JOB  IBM 1401 MUSIC
102            CTL  6611  *6=16,000C;6=16,000T;1=OBJDECK;,1=MODADD
103  *
104  RDBUFF    EQU  1                   * READ BUFFER   (1-80)
105  PUBUF1    EQU  102                 * READ BUFFER PLUS 1
106  PUBUFF    EQU  101                 * PUNCH BUFFER  (101-181)
107  PRBUFF    EQU  201                 * PRINT BUFFER  (201-332)
108  *
109            ORG  85
110            DCW  @X1@
111  X1        DCW  000                 * INDEX REGISTER 1
112            DC   @X2@
113  X2        DCW  000                 * INDEX REGISTER 2
114            DC   @X3@
115  X3        DCW  000                 * INDEX REGISTER 3
116  *
117            ORG  350
118  PID       DCW  @IBM 1401 MUSIC PROGRAM 4-14-2010 REVISION 5.8@
119  GRPMRK    DC   @"@                 * DEFINE GROUP MARK
120  *
121  ONEAD     DSA  001                 * ONE MORE FOR MA
122  TWOAD     DSA  002                 * TWO MORE FOR MA
123  MA1K      DSA  1000                * DEFINE 1 K
124  MA2K      DSA  2000                * DEFINE 2 K
125  MA3K      DSA  3000                * DEFINE 3 K
126  TMPFLG    DCW  @TMP@               * A FLAG TO SET TEMPO
128  *
129  ***** PROGRAM CONSTANTS ****************************************
130  *   THESE VARABLES ARE TO MAKE THE DIVIDE EASIER TO UNDERSTAND *
131  ****************************************************************
132  A         DCW  00              * DIVISOR
133  BH        DCW  00000           * ANSWER
134  BL        DC   0000            * ANSWER
135  MA        DCW  0
136  MBH       DCW  000
137  MBL       DC   00
138  STAN1     DCW  0
139  *
140  LOCS      DCW  000    * HOW MANY LOCATIONS TO MOVE FOR THIS NOTE
141  TIME      DCW  000    * TIME FOR WHOLE NOTE * 10
142  OCTNUM    DCW  @024@           * START IN THE THIRD OCTAVE ((3-1)*12)
143  NTCNT     DCW  @000@           * NOTE COUNTER
144  ERRMK     DCW  @ @             * MARKER FOR CARD INPUT ERROR
145  NOTEX     DCW  0000            * NUMBER OF NOTES TO PLAY
146  *
147  NOTE      DCW  @000@           * STORE THE NOTE
148  TEMPO     DCW  @3@             * DEFAULT TEMPO
149  HOLD1     DCW  0               * STORE A CHARACTER
150  HOLD2     DCW  00              * STORE 2 CHARACTERS
151  HOLD3     DCW  000             * STORE 2 CHARACTERS
152  NOTEL     DCW  @00@            * NOTE SIZE
153  MARK      DCW  @*@             * MARKER FOR ERROR
154  LOOPS     DCW  000             * MOW MANY LOOPS REQUIRED?
155  WMPOS     DCW  000             * WHERE TO SET THE WM
156  JMPLOC    DCW  000             * WHERE TO JUMP INTO THE MCW TABLE
157  *
158  START     NOP                  * GET READY TO GO
159            CS   332             * CLEAR PRINT BUFFER
160            CS                   * CLEAR PRINT BUFFER
161            CS   180             * CLEAR PUNCH BUFFER
162            MCW  PID,240         * ID OUR PROGRAM
163            W                    * PRINT IT
164            CS   299             * CLEAR PRINT BUFFER
165  *
166            MCW  @000@,X1        * INITIALIZE X1
167            MCW  @000@,X2        * INITIALIZE X2
168            MCW  @000@,X3        * INITIALIZE X3
169            MCW  GRPMRK,MVTBL    * PUT IN 6 BITS OF DATA TO MOVE
170            MCW  MVTBL,MVTBL-1   * FILL TABLE WITH DATA
171  *
172  *  WE HAVE TO SETUP THE MOVE TABLE
173  *  WHILE THIS COULD BE BUILT BY THE ASSEMBLER,
174  *  IT WOULD ADD GREATLY TO THE SIZE OF THE OBJECT DECK.
175  *
176            MCW  @006@,X1          * SET X1 TO ZERO
177            MCW  @000@,LOOPS       * ZERO LOOPS
178  MVT1      LCA  MMMMM&6,MITBL&X1  * ADD AN INSTRUCTION
179            A    @1@,LOOPS         * ADD 1 TO LOOP COUNT
180            BCE  MVT2,LOOPS-2,5    * HAVE WE HIT 500 YET?
181            MA   @007@,X1          * INCREMENT X1
182            B    MVT1              * GO LOOP AGAIN
183  *
184  MVT2      MA   @004@,X1          * INCREMENT X1
185            LCA  NNNNN&3,MITBL&X1  * ADD A "B   PLAY4" INSTRUCTION
186            MA   @004@,X1          * INCREMENT X1
187            LCA  NNNNN&3,MITBL&X1  * ADD A "B   PLAY4" INSTRUCTION
188  RDCRD     CS   080               * CLEAR READ BUFFER
189            CS   180               * CLEAR THE PUNCH BUFFER
190            MCW  @000@,X1          * INITIALIZE X1
191            MCW  @000@,X2          * INITIALIZE X2
192            R                      * READ A CARD
               SW   201               * SET WM IN PRINT BUFFER
               MCW  080,280           * MOVE CARD TO PRINT BUFFER
               W                      * PRINT CARD
               CS                     *CLEAR PRINT BUFFER
193  *
194  * SQUEEZE DATA FROM CARD BUFFER TO PUNCH BUFFER
195  *
196  LOP1      BCE  ASKOUT,001&X1,*     * IS IT A * ?
               BCE  BLANK,001&X1,      * IS IT A SPACE?
197            SW   001&X1             * SET A WM FOR MOVE
198            MCW  001&X1,101&X2      * MOVE IN THE NON-SPACE CHAR
199            MA   ONEAD,X2           * INCREMENT X2
200  BLANK     MA   ONEAD,X1           * INCREMENT X2
201            C    @080@,X1           * SEE IF WE ARE DONE
202            BL   LOP1               * DO MORE OF THE CARD
     ASKOUT    NOP                     * EXIT WHEN AN * IS FOUND
203  *
204  *  DONE WITH SQUEEZE
205  *
206  *DEBUG
207            SW   201                * PRINT SQUIZED CARD
208            MCW  180,280
209            W                       * PRINT COMPRESSED CARD
210            CS   299
211  *
212  * ARE WE AT A TERMINUS?
213  *
214            C    PUBUFF&4,@(EOM)@   * IS IT THE END OF THE DECK?
215            BE   PLAY               * LETS GO PLAY
216            C    PUBUFF&4,@(EOF)@   * IS IT THE END OF THE DECK?
217            BE   EXIT               * LETS GO HOME
218  *
219  * NOW WE PROCESS ALL OF THE DATA FOR MUSIC
220  *
221            MCW  @000@,X1          * INITIALIZE X1
222  NXTNT     MCW  @000@,NOTEL       * INITIALIZE NOTE LENGTH
223            MCW  PUBUFF&X1,HOLD1   * PICK UP THE CHARACTER
224            BCE  RDCRD,HOLD1,      * IF WE ARE AT A SPACE
225  *                                * WE ARE DONE WITH THIS CARD
226            MCW  HOLD1,STAN1
227            BCE  OCTV,HOLD1,O      * IS IT AN OCTAVE?
228            BCE  NOTEA,HOLD1,A     * IS IT AN A NOTE?
229            BCE  NOTEB,HOLD1,B     * IS IT AN B NOTE?
230            BCE  NOTEC,HOLD1,C     * IS IT AN C NOTE?
231            BCE  NOTED,HOLD1,D     * IS IT AN D NOTE?
232            BCE  NOTEE,HOLD1,E     * IS IT AN E NOTE?
233            BCE  NOTEF,HOLD1,F     * IS IT AN F NOTE?
234            BCE  NOTEG,HOLD1,G     * IS IT AN G NOTE?
235            BCE  NOTES,HOLD1,S     * IS IT AN S NOTE?
236            BCE  TEMPS,HOLD1,T     * IS IT A TEMPO CMD?
237            B    CARDER            * WE HAVE A CARD ERROR
238  *
239  OCTV      MA   ONEAD,X1          * INCREMENT X1
240            MCW  PUBUFF&X1,HOLD1   * PICK UP THE CHARACTER
241            BCE  OCTV1,HOLD1,1     * IS IT  1?
242            BCE  OCTV2,HOLD1,2     * IS IT  2?
243            BCE  OCTV3,HOLD1,3     * IS IT  3?
244            BCE  OCTV4,HOLD1,4     * IS IT  4?
245            BCE  OCTV5,HOLD1,5     * IS IT  5?
246            B    CARDER            * WE HAVE A CARD ERROR
247  *
248  OCTV1     MCW  @000@,OCTNUM      * SET THE OCTAVE TO 1
249            B    OCTVX             * EXIT FUNCTION
250  OCTV2     MCW  @012@,OCTNUM      * SET THE OCTAVE TO 2
251            B    OCTVX             * EXIT FUNCTION
252  OCTV3     MCW  @024@,OCTNUM      * SET THE OCTAVE TO 3
253            B    OCTVX             * EXIT FUNCTION
254  OCTV4     MCW  @036@,OCTNUM      * SET THE OCTAVE TO 4
255            B    OCTVX             * EXIT FUNCTION
256  OCTV5     MCW  @048@,OCTNUM      * SET THE OCTAVE TO 5
257            B    OCTVX             * EXIT FUNCTION
258  OCTVX     MA   ONEAD,X1          * INCREMENT X1
259            B    NXTNT             * GO GET NEXT NOTE
260  *
261  *
262  NOTEA     MCW  @001@,NOTE        * SET THE NOTE
263            B    CHECK             * CHECK THE MODIFIER
264  NOTEB     MCW  @003@,NOTE        * SET THE NOTE
265            B    CHECK             * CHECK THE MODIFIER
266  NOTEC     MCW  @004@,NOTE        * SET THE NOTE
267            B    CHECK             * CHECK THE MODIFIER
268  NOTED     MCW  @006@,NOTE        * SET THE NOTE
269            B    CHECK             * CHECK THE MODIFIER
270  NOTEE     MCW  @008@,NOTE        * SET THE NOTE
271            B    CHECK             * CHECK THE MODIFIER
272  NOTEF     MCW  @009@,NOTE        * SET THE NOTE
273            B    CHECK             * CHECK THE MODIFIER
274  NOTEG     MCW  @011@,NOTE        * SET THE NOTE
275            B    CHECK             * CHECK THE MODIFIER
276  NOTES     MCW  @999@,NOTE        * SET THE NOTE
277            B    CKX               * CHECK THE MODIFIER EXIT
278  *
279  TEMPS     MA   ONEAD,X1          * INCREMENT X1
280            MCW  PUBUFF&X1,TEMPO   * PICK UP THE CHARACTER
281            BCE  TEPEX,TEMPO,1     * IS IT  1?
282            BCE  TEPEX,TEMPO,2     * IS IT  2?
283            BCE  TEPEX,TEMPO,3     * IS IT  3?
284            BCE  TEPEX,TEMPO,4     * IS IT  4?
285            BCE  TEPEX,TEMPO,5     * IS IT  5?
286            B    CARDER            * WE HAVE A CARD ERROR
287  TEPEX     MCW  TMPFLG,LOCS       * PUT IN A FLAG TO SHOW THE TEMPO IS CHANG
288            MCW  @000@,JMPLOC      * CLEAR THE FIELD
289            MCW  TEMPO,JMPLOC      * PUT TEMPO IN FIELD
290  *
291            MA   ONEAD,X1          * POINT TO NEXT POSITION
292            MCW  PUBUFF&X1,HOLD1   * PICK UP THE NEXT CHARACTER
293            B    SHORTC            * BRANCH TO SHORTCUT
294  *
295  CHECK     MA   ONEAD,X1          * POINT TO NEXT POSITION
296            MCW  PUBUFF&X1,HOLD1   * PICK UP NEXT CHARACTER
297            BCE  CK1,HOLD1,#       * SHARP?
298            BCE  CK1,HOLD1,+       * SHARP?
299            BCE  CK2,HOLD1,-       * FLAT?
300            B    NOTSZ             * GO GET NOTE SIZE
301  *
302  CK1       A    @1@,NOTE          * GO UP ONE
303            B    CKX               * OUT OF HERE
304  *
305  CK2       S    @1@,NOTE          * DOWN ONE STEP
306            MZ   NOTE-1,NOTE       * CLEAR ZONE
307            C    @000@,NOTE        * CHECKING FOR ZERO
308            BH   CKX               * BRANCH IF OVER ZERO
309            MCW  @001@,NOTE        * SET TO 1
310  *
311  CKX       MA   ONEAD,X1          * POINT TO NEXT POSITION
312            MCW  PUBUFF&X1,HOLD1   * PICK UP THE NEXT CHARACTER
313  *
314  * THE FOLLOWING CODE DETERMINES THE LENGTH OF THE CURRENT
315  * NOTE. A 1 IS A WHOLE NOTE A 4 IS A QUARTER NOTE
316  * A 16 IS A 16TH NOTE.
317  *
318  NOTSZ     C    HOLD1,@Z@         * SEE IF NUMERIC
319            BL   GOT1              * FOUND 1 NUMBER
320            B    CARDER            * WE HAVE A CARD ERROR
321  GOT1      C    PUBUFF&1&X1,@Z@   * SEE IF NEXT IS NUMERIC
322            BL   DIG2              * WE HAVE TWO DIGITS
323  *   ELSE WE HAVE ONLY ONE DIGIT
324  DIG1      MCW  HOLD1,NOTEL       * SET NOTE LENGTH
325            MA   ONEAD,X1          * POINT TO NEXT POSITION
326            B    STORN             * STORE THE NOTE
327  *
328  *   TWO DIGITS
329  DIG2      MCW  HOLD1,NOTEL-1     * PUT IT IN ITS PLACE
330            MCW  PUBUFF&1&X1,HOLD1   * GET FIRST CHARACTER
331            MCW  HOLD1,NOTEL       * PUT IT IN ITS PLACE
332            MA   TWOAD,X1          * POINT TO NEXT POSITION
333            B    STORN             * STORE THE NOTE
334  *
335  * STORE THE NOTE IN A TABLE TO BE PLAYED LATER
336  * VARIABLES AVAILABLE AT THIS POINT ARE
337  *   NOTE   = PLACE IN MUSIC TABLE (TBL)
338  *   OCTAVE = OFFSET IN MUSIC TABLE (TBL) DUE TO OCTAVE
339  *   NOTEL  = DIVISION OF FULL NOTE
340  *               1 = FULL NOTE
341  *               2 = HALF NOTE
342  *               4 = QUARTER NOTE ETC
343  *
344  *
345  *                     * 1=WHOLE, 2=HALF, 4=QUARTER
346  *
347  * CALCULATE AND STORE NOTE
348  * STORE NOTE
349  *
350  STORN     C    @900@,NOTE      * DO WE HAVE AN "S" HIDING AS 999?
351            BL   STOR2           * NO, COMMON NOTE
352            MCW  @0000@,BL       * FIRST ENTRY IN NOTE TABLE
353  *   000 IS THE VALUE OF A IN OCTIVE 1 LOWEST NOTE
354  *   WE USE THIS FOR SILENCE
355  *
356            B    STOR4           * BYPASS OCTAVE OFFSET
357  *
358  STOR2     ZA   NOTE,A          * PICKUP NOTE VALUE
359  *                              *     (1-12)
360            A    OCTNUM,A        * ADD THE OCTAVE OFFSET
361  *                              *   (0,12,24,36,48)
362            S    @1@,A           * CHANGE TO ZERO BASED   (-1)
363            MZ   A-1,A           * CLEAR ZONE
364  *
365            ZA   @0@,BL          * ZERO OUT BH & BL
366            MCW  @6@,BH          * 6 CHARTERS PER NOTE ENTRY
367  *                              *   3 FOR LEN OF MEMORY MOVE
368  *                              *   3 FOR NUMBER OF LOOPS
369            M    A,BL            * MULTIPLY
370  STOR4     MZ   BL-1,BL         * CLEAR ZONE
371            MCW  BL-1,X2         * GET THE ANSWER
372  ************************************************************************
373            MCW  TBL&X2-3,LOCS   * PICK UP NUMBER OF CHARACTERS
374  *                              * TO BE MOVED EQACH LOOP
375  *
376  *  NOW WE NEED TO CONVERT THE NUMBER OF CARDS TO
377  *  WHERE TO SET THE WM IN THE DATA BEING MOVED
378  *
379            MCW  @999@,WMPOS     * INITIALIZE WMPOS
380            S    LOCS,WMPOS      * INVERT LOCS
381            MZ   WMPOS-1,WMPOS   * CLEAR ZONE
382            MCW  WMPOS,LOCS
383  ************************************************************************
384            MCW  TBL&X2,TIME     * PICK UP NUMBER OF LOOPS
385  *                              * FOR A WHOLE NOTE
386  *
387  *     FOR A WHOLE NOTE, NOTEL = 1, HALF NOTE IS 2,
388  *                                  QUARTER NOTE IS A 4
389  *     NEED TO DIVIDE THE TIME BY NOTEL TO GET THE
390  *     CORRECT NOTE TIMING
391  *
392            ZA   TIME,BL         * LOAD DIVIDEND
393            ZA   NOTEL,A         * LOAD DIVISOR
394            D    A,BH            * THE MAGIC DIVIDE
395            MCW  BL-3,LOOPS      * STORE THE RESULTS
396            MZ   LOOPS-1,LOOPS   * CLEAR SIGN
397            C    LOOPS,@001@     * HAVE WE GONE TO ZERO?
398            BL   OKNUM           * OK, = 2 OR GT 001
399            MCW  @001@,LOOPS     * THAT FIXES IT
400  OKNUM     NOP                  * KEEP CODE CLEAN
401  *
402            MCW  @500@,HOLD3     * INITIALIZE HOLD3
403            S    LOOPS,HOLD3     * INVERT LOOPS
404            MCW  HOLD3,LOOPS     * RESTORE
405            MZ   LOOPS-1,LOOPS   * CLEAR ZONE
406  *
407  *
408  * MULTIPLY BY 7 (M AAA AAA)
409  *
410            ZA   @7@,MA           * PUT IN A
411            ZA   LOOPS,MBH        * PUT IN BH
412            M    MA,MBL           * MULTIPLY
413            MZ   MBL-1,MBL        * CLEAR ZONE
414  *
415  CKSZ      MCW  @000@,JMPLOC     * INITIALIZE LPPOS
416  CKSZ2     C    MBL,@00999@      * SEE HOW BIG IT IS
417            BH   SMALL            * WE ARE UNDER 999
418            S    @999@,MBL        * SUBTRACT 999 FROM MBL
419            MZ   MBL-1,MBL
420            MA   @999@,JMPLOC     * TO INDEX
421            B    CKSZ2
422  *
423  SMALL     MCW  MBL,HOLD3
424            MA   HOLD3,JMPLOC       * ADD IN THE SMALL STUFF
425  *
426  *  IT IS NOW TIME TO PUT THE DATA INTO TABLES
427  *  TO BE PLAYED
428  *
429  SHORTC    LCA  LOCS,NTTBL&X3     * STORE THE NOTE
430            LCA  JMPLOC,DRTBL&X3   * STORE THE DURATION
431            MA   @003@,X3          * KICK UP X3 BY 3 LOCATIONS
432            A    @1@,NTCNT         * COUNT THE NOTES STORED
433            C    @998@,NTCNT       * SEE IF WE HAVE TO MANY NOTES
434            BL   NXTNT             * NOT YET
435  *
436  *    YOU ONLY GET HERE IF YOU HAVE ENTERED
437  *    1000 NOTES TO PLAY
438  *
439            CS   332             * CLEAR PRINT STORAGE
440            CS                   * CLEAR PRINT STORAGE
441            MCW  @ERROR ***** YOU HAVE EXCEEDED @
442            MCW  @THE 1000 NOTE LIMIT@,250
443            W                    * PRINT
444            CC   1               * PAGE EJECT
445            CS   332             * CLEAR PRINT STORAGE
446            CS                   * CLEAR PRINT STORAGE
447            W                    * PRINT
448            B    EXIT            * GO HOME
449  *
450  **********************************************************
451  *         DUMMY ENTRY TO LOAD THE MVTBL
452  MMMMM     MCW  MVTBL,MVTBL   * JUST TO TAKE UP TIME
453  NNNNN     B    PLAY8         * LAST ENTRY IN TABLE
454  *
455  **********************************************************
456  PLAY      BCE  EXIT,ERRMK,E    * IF YOU HAD AN ERROR, GO HOME
457  *
458            LCA  @END@,NTTBL&X3   * STORE THE NOTE END
459            LCA  @END@,DRTBL&X3   * STORE THE DURATION END
460  *
461  *  SO NOW THAT WE HAVE THE NOTES AND DURATIONS STORED IN THE TABLES
462  *
463            CS   332               * CLEAR PRINT STORAGE
464            CS
465  *
466  ****************************************************
467  *                                                  *
468  *     AFTER ALL OF THIS WORK, WE GET TO            *
469  *     PLAY THE MUSIC!!!!!!!                        *
470  ****************************************************
471  *
472  PLAY4     MCW  @000@,X1          * INITIALIZE X1
475  PLAY7     MCW  NTTBL&X1,X2       * PICK UP THE NOTE
476            MCW  DRTBL&X1,X3       * PICK UP THE DURATION
477            BCE  QLOOP,X2,D        * ARE WE DONE?
478            BCE  SETTMP,X2,P       * IS IT TEMPO?
479  *
480  *
481            MCW  TEMPO,HOLD1       * SET IT UP FOR COUNTING
482            MCW  @TEMPO@,210
483            MCW  TEMPO,220
484            MCW  @NOTE@,230
485            MCW  X2,240
486            MCW  @LENG@,250
487            MCW  X3,260
488            SW   MOVTBL&X2         * SET WM FOR NOTE
489  PLAY75    B    MITBL&X3          * BRANCH INTO TABLE OF MOVES
490  PLAY8     A    @1@,HOLD1         * INCREMENT COUNT
499            BCE  PLAY9,HOLD1,6     * DONE ENOUGHT?
500  *
501            B    PLAY75            * DO ANOTHER ONE
502  *
503  PLAY9     CW   9000&X2           * CLEAR WM FOR NOTE
504            MA   @003@,X1          * INCREMENT X1
505            B    PLAY7             * NEXT NOTE
506  *
507  SETTMP    MCW  X3,TEMPO          * USE UNTIL NEXT TEMPO CHANGE
508            B    PLAY9             * GO BACK TO WHERE WE WERE
509  *
510  QLOOP     B    PLAY4,G           * IF SS G IS ON, PLAY IT AGAIN
511            MCW  @000@,X3          * INITIALIZE X3
512            B    RDCRD             * OTHERWISE GO READ THE NEXT DECK
513  *
514  ****************************************************
515  *   YOU HAVE HAD A CODING ERROR IN THE INPUT CARD DECK
516  *   NO SENSE TO GO ON FROM HERE
517  ****************************************************
518  *
519  CARDER    SW   201
520            MCW  180,280
521            MCW  @INPUT CARD ERROR@,300
522            W
523            CS   332
524            CS
525            MCW  MARK,201&X1
526            W
527            CS   332
528            CS
529            W
530            MCW  @E@,ERRMK       * NOTE THE ERROR
531            B    RDCRD
532  *
533  **********************************************************
534  *         GET READY TO BOOT FROM THE FOLLOWING DECK
535  *
536  EXIT      NOP  999,999         * LOAD A & B REGISTERS
537            H                    * READY FOR NEXT PROGRAM?
538            CS   332             * CLEAR PRINT STORAGE
539            CS                   * CLEAR PRINT STORAGE
540            CS                   * CLEAR PUNCH STORAGE
541            CS                   * CLEAR READ STORAGE
542            SW   001             * SET WORDMARK IN LOCATION 1
543  NREAD     R                    * READ FIRST CARD OF NEXT DECK
544            BCE  001,001,,       * IS IT A COMMA? BRANCH TO
545  *                              * THE FIRST INSTRUCTION
546            B    NREAD           * CHECK THE NEXT ONE
547            NOP
548  *********************************************************
549  * FIVE OCTAVES OF NOTES
550  * TWELVE NOTES PER OCTAVE
551  * FIRST 3 DIGITS DEFINES THE LENGTH OF EACH MOVE
552  * THE LAST 5 DIGITS = THE NUMBER OF MOVES PER WHOLE NOTE
553  * XXX.XX
554  * THIS IS USED TO DETERMINE HOW MANY
555  * MOVES TO PLAY A FULL NOTE OF 256 MS.
556  * TO PLAY A FULL "D" NOTE, FIRST OCTAVE,
557  * YOU MUST MOVE 701 LOCATIONS 16 TIMES.
558  *
559  TBL       DCW  @788014@     * A       (1) 14 LOOPS A FULL NOTE
560            DCW  @743015@     * A#,A+,B-(2)
561            DCW  @701016@     * B,C-    (3)
562            DCW  @662017@     * C       (4)
563            DCW  @624018@     * C#,C+,D-(5)
564            DCW  @589019@     * D       (6)
565            DCW  @556020@     * D#,D+,E-(7)
566            DCW  @525021@     * E       (8)
567            DCW  @495022@     * F       (9)
568            DCW  @467024@     * F#,F+,G-(10)
569            DCW  @441025@     * G       (11)
570            DCW  @416026@     * G#,G+,A-(12)
571            DCW  @392028@     * AND SO ON
572            DCW  @370030@
573            DCW  @349031@
574            DCW  @329033@
575            DCW  @311035@
576            DCW  @293037@
577            DCW  @276040@
578            DCW  @261042@
579            DCW  @246044@
580            DCW  @232047@
581            DCW  @219050@
582            DCW  @206053@
583            DCW  @195056@
584            DCW  @184059@
585            DCW  @173063@
586            DCW  @163066@
587            DCW  @154070@
588            DCW  @145074@
589            DCW  @137079@
590            DCW  @129083@
591            DCW  @121089@
592            DCW  @115093@
593            DCW  @108099@
594            DCW  @102105@
595            DCW  @096111@
596            DCW  @090118@
597            DCW  @085125@
598            DCW  @080132@
599            DCW  @075140@
600            DCW  @071148@
601            DCW  @067156@
602            DCW  @063165@
603            DCW  @059176@
604            DCW  @056185@
605            DCW  @052198@
606            DCW  @049209@
607            DCW  @046222@
608            DCW  @044231@
609            DCW  @041246@
610            DCW  @039258@
611            DCW  @036277@
612            DCW  @034291@
613            DCW  @032308@
614            DCW  @030326@
615            DCW  @028346@
616            DCW  @026369@
617            DCW  @025382@
618            DCW  @023410@
619  SILEN     DCW  @023410@    *SILENCE ??????
620  *
621  *******************************************************
622  *
623  * SET ASIDE 1000 CHARACTRS TO BE MOVED
624  *
625  MOVTBL    DA   1X1000              *
626  MVTBL     DC   0                   * END OF TABLE
627  *******************************************************
628  *
629  * 999 ENTRY TABLE TO HOLD NOTES TO BE PLAYED
630  *
631  NTTBL     DA   1X3000   * FIRST ENTRY IN TABLE
632  ************************************************************
633  *
634  * 999 ENTRY TABLE TO DURATION ENTRIES
635  *
636  DRTBL     DA   1X3000   * FIRST ENTRY IN TABLE
637  *
638  *************************************************************
639  * TABLE OF MOVE INSTRUCTIONS INSTRUCTIONS (500) FOLLOW
640  * PLUS 2 BRANCH PLAY8 INSTRUCTIONS
641  *
642  MITBL     DA   7X510    * FIRST ENTRY IN TABLE
643  *************************************************************
644  *     HOW IT WORKS
645  *     (1) READ A CARD AND COMPRESS IT
646  *     (2) PICK A CHARACTER FROM THE CARD
647  *     (3) IF OCTAVE, PICK UP NUMBER AND SET THE VALUE IN OCTNUM
648  *     (4) IF A NOTE, SET THE NOTE NUMPER
649  *         (4.1) IF SHARP OR FLAT, MODIFY NOTE NUMBER
650  *         (4.2) PICK UP THE NOTE SIZE AND STORE NOTE LENGHT
651  *     (5)  USING NOTE + OCTAVE AS AN INDEX, PULL MOVE SIZE AND
652  *          NOTE LOOPS FROM TABLE
653  *     (6)  MOVE SIZE IS FROM 1 TO 1000 CHARACTERS.
654  *          THE SIZE IS DEFINED WHERE A WM IS SET IN AN OPEN FIELD.
655  *          THE MOVE SIZE IS SUBTRACTED FROM 1000 TO GET THE LOCATION
656  *          FROM THE TOP ADDRESS TO SET THE WM AS INDEXING IS POSITIVE ONLY
657  *     (7)  CONVERT THE DECIMAL NUMBER TO A THREE DIGIT IBM 1401 ADDRESS.
658  *     (8)  THERE ARE 550 POSSIBLE LOOP ENTRY LOCATIONS AND EACH ENTRY
659  *          IS 7 CHARACTERS LONG. LOOPS ARE MULTIPLIED BY 7 AND THEN
660  *          THE INDEX HAS TO BE POSITIVE SO LOOPS ARE SUBTRACTED FROM 550.
661  *     (9)  CONVERT THE DECIMAL NUMBER TO A THREE DIGIT IBM 1401 ADDRESS.
662  *     (10) STORE THE LENGTH AND THE LOOP VALUE IN A TABLE TO BE PLAYED LATE
663  *     PLAY
664  *     (1)  PULL A NOTE FROM TABLE
665  *     (2)  SET A WM AS REQUIRED FOR MOVE LENGTH
666  *     (3)  BRANCH INDEXED INTO PLAY TABEL
667  *     (4)  CLEAR WM
668  *     (5)  REPEAT
669  *
670            END  START
