0000000000               JOB  IBM 1401 MUSIC
               CTL  6611  *6=16,000C;6=16,000T;1=OBJDECK;,1=MODADD
     *
     RDBUFF    EQU  1                   * READ BUFFER   (1-80)
     PUBUF1    EQU  102                 * READ BUFFER PLUS 1
     PUBUFF    EQU  101                 * PUNCH BUFFER  (101-181)
     PRBUFF    EQU  201                 * PRINT BUFFER  (201-332)
     ONEAD     DSA  001                 * ONE MORE FOR MA
     TWOAD     DSA  002                 * TWO MORE FOR MA
     *
               ORG  85
               DCW  @X1@
     X1        DCW  000                 * INDEX REGISTER 1
               DC   @X2@
     X2        DCW  000                 * INDEX REGISTER 2
               DC   @X3@
     X3        DCW  0000                * INDEX REGISTER 3
     *
               ORG  350
     *
               DCW  @IBM 1401 MUSIC PROGRAM 01-15-2010@
     *
     ***** PROGRAM CONSTANTS ******
     OCTNUM    DCW  @024@           * START IN THE THIRD OCTAVE (3*12)
     CDCNT     DCW  @000@           * CARD COUNTER
     *
     NOTE      DCW  @000@           * STORE THE NOTE
     HOLD1     DCW  0               * STORE A CHARACTER
     HOLD2     DCW  00              * STORE 2 CHARACTERS
     NOTEL     DCW  @000@           * NOTE SIZE
     MARK      DCW  @*@             * MARKER FOR ERROR
     *
     START     H                    * GET READY TO GO
               CS   332             * CLEAR PRINT BUFFER
               CS                   * CLEAR PRINT BUFFER
               CS   180             * CLEAR PUNCH BUFFER
               CS   080             * CLEAR READ BUFFER
     *
     RDCRD     CS   080             * CLEAR READ BUFFFER
               R                    * READ A CARD
               CS   180             * CLEAR THE PUNCH BUFFER
     *
     * SQUEEZE DATA FROM CARD BUFFER TO PUNCH BUFFER
     *
               MCW  @000@,X1
               MCW  @000@,X2           * INITIALIZE X1 AND X2
               MCW  @000@,CDCNT        * INITIALIZE CARD COUNT
     LOP1      BCE  BLANK,001&X1,      * IS IT A SPACE?
               SW   001&X1             * SET A WM FOR MOVE
               MCW  001&X1,101&X2      * MOVE IN THE NON-SPACE CHAR
               MA   ONEAD,X2           * INCREMENT X2
     BLANK     MA   ONEAD,X1           * INCREMENT X2
               C    @080@,X1           * SEE IF WE ARE DONE
               BL   LOP1               * DO MORE OF THE CARD
     *  DONE WITH SQUEEZE
               SW   201
               MCW  180,280
               W             * PRINT COMPRESSED CARD
               CS   299
     *
     * ARE WE AT A TERMINUS?
     *
               C    PUBUFF&4,@(EOM)@   * IS IT THE END OF THE DECK?
               BE   PLAY               * LETS GO PLAY
               C    PUBUFF&4,@(EOF)@   * IS IT THE END OF THE DECK?
               BE   EXIT               * LETS GO HOME
     *
     * NOW WE PROCESS ALL OF THE DATA FOR MUSIC
     *
               MCW  @000@,X1          * INITIALIZE X1
     NXTNT     MCW  @000@,NOTEL       * INITIALIZE NOTEL
               MCW  PUBUFF&X1,HOLD1   * PICK UP THE CHARACTER
               BCE  RDCRD,HOLD1,      * IF WE ARE AT A SPACE
     *                                * WE ARE DONE WITH THIS CARD
               BCE  OCTV,HOLD1,O      * IS IT AN OCTAVE?
               BCE  NOTEA,HOLD1,A     * IS IT AN A NOTE?
               BCE  NOTEB,HOLD1,B     * IS IT AN B NOTE?
               BCE  NOTEC,HOLD1,C     * IS IT AN C NOTE?
               BCE  NOTED,HOLD1,D     * IS IT AN D NOTE?
               BCE  NOTEE,HOLD1,E     * IS IT AN E NOTE?
               BCE  NOTEF,HOLD1,F     * IS IT AN F NOTE?
               BCE  NOTEG,HOLD1,G     * IS IT AN G NOTE?
               BCE  NOTES,HOLD1,S     * IS IT AN S NOTE?
               B    CARDER            * WE HAVE A CARD ERROR
     *
     OCTV      A    @1@,X1            * INCREMENT X1
               MCW  PUBUFF&X1,HOLD1   * PICK U THE CHARACTER
               BCE  OCTV1,HOLD1,1     * IS IT  1?
               BCE  OCTV2,HOLD1,2     * IS IT  2?
               BCE  OCTV3,HOLD1,3     * IS IT  3?
               BCE  OCTV4,HOLD1,4     * IS IT  4?
               BCE  OCTV5,HOLD1,5     * IS IT  5?
               B    CARDER            * WE HAVE A CARD ERROR
     *
     OCTV1     MCW  @000@,OCTNUM      * SET THE OCTAVE TO 1
               B    OCTVX             * EXIT FUNCTION
     OCTV2     MCW  @012@,OCTNUM      * SET THE OCTAVE TO 2
               B    OCTVX             * EXIT FUNCTION
     OCTV3     MCW  @024@,OCTNUM      * SET THE OCTAVE TO 3
               B    OCTVX             * EXIT FUNCTION
     OCTV4     MCW  @036@,OCTNUM      * SET THE OCTAVE TO 4
               B    OCTVX             * EXIT FUNCTION
     OCTV5     MCW  @048@,OCTNUM      * SET THE OCTAVE TO 5
               B    OCTVX             * EXIT FUNCTION
     OCTVX     MA   ONEAD,X1          * INCREMENT X1
               MCW  @OCTAVE = @,215
               MCW  OCTNUM, 220
               MCW  X1,230
               W
               CS   299
               B    NXTNT             * GO GET NEXT NOTE
     *
     *
     NOTEA     MCW  @001@,NOTE        * SET THE NOTE
               B    CHECK             * CHECK THE MODIFIER
     NOTEB     MCW  @003@,NOTE        * SET THE NOTE
               B    CHECK             * CHECK THE MODIFIER
     NOTEC     MCW  @004@,NOTE        * SET THE NOTE
               B    CHECK             * CHECK THE MODIFIER
     NOTED     MCW  @006@,NOTE        * SET THE NOTE
               B    CHECK             * CHECK THE MODIFIER
     NOTEE     MCW  @008@,NOTE        * SET THE NOTE
               B    CHECK             * CHECK THE MODIFIER
     NOTEF     MCW  @009@,NOTE        * SET THE NOTE
               B    CHECK             * CHECK THE MODIFIER
     NOTEG     MCW  @011@,NOTE        * SET THE NOTE
               B    CHECK             * CHECK THE MODIFIER
     NOTES     MCW  @004@,NOTE        * SET THE NOTE
               B    CHECK             * CHECK THE MODIFIER EXIT
     CHECK     MCW  @NOTE = @,210
               MCW  NOTE,215
               MCW  X1,230
               W
               CS   299
               MA   ONEAD,X1          * POINT TO NEXT POSITION
               MCW  PUBUFF&X1,HOLD1   * PICK UP NEXT CHARACTER
               BCE  CK1,HOLD1,#       * SHARP?
               BCE  CK1,HOLD1,+       * SHARP?
               BCE  CK2,HOLD1,-       * FLAT?
               B    NOTSZ             * GO GET NOTE SIZE
     CK1       A    @1@,NOTE          * GO UP ONE
               B    CKX               * OUT OF HERE
     CK2       S    @1@,NOTE          * DOWN ONE STEP
               MZ   NOTE-1,NOTE       * CLEAR ZONE
     CKX       MA   ONEAD,X1          * POINT TO NEXT POSITION
               MCW  @NOTE = @,210
               MCW  NOTE,215
               MCW  X1,230
               W
               CS   299
     *
     * THE FOLLOWING CODE DETERMINES THE LENGTH OF THE CURRENT
     * NOTE. A 1 IS A WHOLE NOTE A 4 IS A QUARTER NOTE
     * A 16 IS A 16TH NOTE.
     *
     NOTSZ     C    HOLD1,@Z@         * SEE IF NUMERIC
               BL   GOT1              * FOUND 1 NUMBER
               B    CARDER            * WE HAVE A CARD ERROR
     GOT1      C    PUBUFF&X1&1,@Z@   * SEE IF NEXT IS NUMERIC
               BL   DIG2              * WE HAVE TWO DIGITS
     *   ELSE WE HAVE ONLY ONE DIGIT
     DIG1      MCW  HOLD1,NOTEL       * SET NOTE LENGTH
               MA   ONEAD,X1          * POINT TO NEXT POSITION
               B    STORN             * STORE THE NOTE
     *
     DIG2      MCW  HOLD1,NOTEL-1     * PUT IT IN ITS PLACE
               MCW  PUBUFF&X1&1,HOLD1   * GET FIRST CHARACTER
               MCW  HOLD1,NOTEL       * PUT IT IN ITS PLACE
               MA   TWOAD,X1          * POINT TO NEXT POSITION
               B    STORN             * STORE THE NOTE
     *
     * STORE THE NOTE IN A TABLE TO BE PLAYED LATER
     * VARIABLES AVAILABLE AT THIS POINT ARE 
     *   NOTE   = PLACE IN MUSIC TABLE (TBL)
     *   OCTAVE = OFFSET IN MUSIC TABLE (TBL) DUE TO OCTAVE
     *   NOTEL  = DIVISION OF FULL NOTE
     *               1 = FULL NOTE
     *               2 = HALF NOTE
     *               4 = QUARTER NOTE ETC
     *   
     *
     CARS      DCW  000    * HOW MANY CHARACTERS TO MOVE FOR THIS NOTE
     TIME      DCW  00000  * TIME FOR WHOLE NOTE * 10
     *                     * 1=WHOLE, 2=HALF, 4=QUARTER
     *
     *   THESE VARABLES ARE TO MAKE THE DIVIDE EASIER TO UNDERSTAND
     A         DCW  000             * DIVISOR
     BH        DCW  00000           * ANSWER
     BL        DC   0000            * DIVIDEN PLUS 1
     *
     STORN     ZA   NOTE,A          * PICKUP NOTE VALUE
               A    OCTNUM,A        * ADD THE OCTAVE OFFSET
               S    @1@,A           * CHANGE TO ZERO BASED
     *
               ZA   @0@,BL          * ZERO OUT BH & BL
               MCW  @8@,BH          * 8 CHARTERS PER NOTE ENTRY
               M    A,BL            * MULTIPLY
               MZ   BL-1,BL         * CLEAR ZONE
               MCW   BL,X2           * GET THE ANSWER
     *
               MCW  TBL&X2-5,CARS   * PICK UP NUMBER OF CARACTERS
               MCW  TBL&X2,TIME     * PICK UP TIME
     *DEBUG
               CS   332
               CS
               MCW  @NOTE @,210
               MCW  NOTE,220
     *
               MCW  @NOTEL@,230
               MCW  NOTEL,240
     *
               MCW  @X1@,250
               MCW  X1,260
     *
               MCW  @CARS @,270
               MCW  CARS,280
     *
               MCW  @TIME@,290
               MCW  TIME,300
     *
               MCW  @X2@,310
               MCW  X2,320
     *
               W
               CS   332
               CS   
               ZA   TIME,BL         * LOAD DIVIDEN
               ZA   NOTEL,A         * LOAD DIVISOR
               D    A,BL            * THE MAGIC DIVIDE
               MCW  @00000@,BH      * SET ZEROS
               MCW  BL-2,TIME       * STORE THE RESULTS 
     *                              * AND DEVIDE BY 100
               MCW  @ NEW TIME = @,220
               MCW  TIME,230
               W
               CS   299
     *DEBUG
               B    NXTNT           * GO NEXT NOTE
     PLAY      H    PLAY
     CARDER    SW   201
               MCW  180,280
               MCW  @ERROR@,310
               W
               CS   332
               CS
               MCW  MARK,201&X1
               W
               CS   332
               CS
               W
               B    RDCRD
     *
     **********************************************************
     *         GET READY TO BOOT FROM THE FOLLOWING DECK
     *
     EXIT      CS   332             * CLEAR PRINT STORAGE
               CS                   * CLEAR PRINT STORAGE
               CS                   * CLEAR PUNCH STORAGE
               CS                   * CLEAR READ STORAGE
               SW   001             * SET WORDMARK IN LOCATION 1
     NREAD     R                    * READ FIRST CARD OF NEXT  DECK
               BCE  001,001,,       * IS IT A COMMA? BRANCH TO
     *                              * THE FIRST INSTRUCTION
               B    NREAD           * CHECK THE NEXT ONE
               NOP
     *********************************************************
     * FIVE OCTAVES OF NOTES
     * TWELVE NOTES PER OCTAVE
     * FIRST 3 DIGITS DEFINES THE LENGTH OF EACH MOVE
     * THE LAST 5 DIGITS = THE NUMBER OF MOVES PER WHOLE NOTE
     * XXX.XX
     * THIS IS USED TO DETERMINE HOW MANY
     * MOVES TO PLAY A FULL NOTE OF 256 MS.
     * TO PLAY A FULL "D" NOTE, FIRST OCTAVE,
     * YOU MUST MOVE 701 LOCATIONS 16 TIMES.
     *
               DCW  @78801449@     * SAFETY IN CASE SOMEBODY
     *                             * CALLS FOR A C- IN THE FIRST OCTAVE
     TBL       DCW  @78801449@     * A(1) 14.49 * 10 MOV A FULL NOTE
               DCW  @74301534@     * A#,A+,B-(2)
               DCW  @70101622@     * B,C-(3)
               DCW  @66201714@     * C (4)
               DCW  @62401815@     * C#,C+,D-(5)
               DCW  @58901919@     * D (6)               
               DCW  @55602029@     * D#,D+,E-(7)          
               DCW  @52502145@     * E(8)
               DCW  @49502271@     * F(9)                  
               DCW  @46702403@     * F#,F+,G-(10)
               DCW  @44102541@     * G (11)
               DCW  @41602689@     * G#,G+,A-(12)
               DCW  @39202849@     * AND SO ON
               DCW  @37003014@
               DCW  @34903190@
               DCW  @32903378@
               DCW  @31103569@
               DCW  @29303782@
               DCW  @27604009@
               DCW  @26104233@
               DCW  @24604484@
               DCW  @23204746@
               DCW  @21905020@
               DCW  @20605328@
               DCW  @19505620@
               DCW  @18405945@
               DCW  @17306312@
               DCW  @16306687@
               DCW  @15407065@
               DCW  @14507488@
               DCW  @13707910@
               DCW  @12908383@
               DCW  @12108916@
               DCW  @11509363@
               DCW  @10809945@
               DCW  @10210505@
               DCW  @09611132@
               DCW  @09011839@
               DCW  @08512501@
               DCW  @08013241@
               DCW  @07514076@
               DCW  @07114824@
               DCW  @06715655@
               DCW  @06316586@
               DCW  @05917636@
               DCW  @05618514@
               DCW  @05219832@
               DCW  @04920951@
               DCW  @04622204@
               DCW  @04423126@
               DCW  @04124663@
               DCW  @03925807@
               DCW  @03627737@
               DCW  @03429192@
               DCW  @03230809@
               DCW  @03032617@
               DCW  @02834649@
               DCW  @02636953@
               DCW  @02538223@
               DCW  @02341046@
     SILEN     DCW  @99941046@    *SILENCE ??????
               ORG  2000     *SPACE FOR NOTE TABLE
     NOTET     DC   0
               ORG  5000     *SPACE FOR DURATION TABLE
     DURT      DC   0
               ORG  8000     *SPACE FOR MOVE TABLE
     MOVT      DCW  0
               END  START
