     ***************************************************************************
     *     SSSSS = CARD SEQUENCE NUMBER          ********** = LABEL
     *     OPER- = OPERATION                     OPERATION--- = OPERATION
SSSSS**********OPER-OPERANDS----------------------------------------------------     **********|****|***********************************************************
               JOB  FIRST PROGRAM
               CTL  6611  *6=16,000C;6=16,000T;1=OBJDECK;,1=MODADD     
     READ      EQU  001                 *DEFINE FRIST CHARACTER OF READ BUFFER
     PUNCH     EQU  101                 *DEFINE FIRST CHARACTER OF PUNCH BUFFER
     PRINT     EQU  201                 *DEFINE FIRST CHARACTER OF PRINT BUFFER
               ORG  87
     X1        DCW  000                 *INDEX REGISTER 1
               DCW  11                  *IDENTIFING FILLER
     X2        DCW  000                 *INDEX REGISTER 2
               DCW  22                  *IDENTIFING FILLER
     X3        DCW  000                 *INDEX REGISTER 3
               DCW  33                  *IDENTIFING FILLER
     *
               ORG  340                 *ORG JUST AFTER PRINT BUFFER
     *
     IDENT     DCW  @IBM 1401 PROGRAM FIRST 2/19/2008@  *ID THE PROGRAM DECK
     *
     *
     START     H                        *HALT TO ALLOW PATCHING IF REQUIRED
     *
     *                                  *CLEAR READ BUFFER AND SET WM
               CS   080                 *CLEAR 080 TO 000
               SW   001                 *SET A WORD MARK AT THE BEGINNING
     *
     *                                  *CLEAR PUNCH BUFFER AND SET WM
               CS   180                 *CLEAR 180 TO 101
               SW   101                 *SET A WORD MARK AT THE BEGINNING
     *
     *                                  *CLEAR PRINT BUFFER AND SET WM
               CS   332                 *CLEAR 332 TO 300
               CS                       *CLEAR 299 TO 200            
               SW   201                 *SET A WORD MARK AT THE BEGINNING                 
     *                                  
     *********************************************************************
     *         UP TO THIS POINT IS BOILER PLATE AND CAN BE USED AS THE
     *         START OF ANY PROGRAM.
     *********************************************************************
     *
     *********************************************************************
     *         THE FOLLOWING CODE WILL READ ONE CARD FROM THE CARD READER 
     *         AND PLACE IT IN MEMORY LOCATIONS 001 THROUGH 080
     *********************************************************************
     *
     P1        R                        *READ A CARD
               H    P2                  *HALT SO YOU CAN EXAMINE 001-080
     *                                  *THEN GO TO P2
     *
     *********************************************************************
     *         THE FOLLOWING CODE WILL MOVE THE CARD DATA FROM THE READ BUFFER
     *         TO THE PUNCH BUFFER AND PUNCH THE CARD.
     *         THIS WILL BE FOLLOWED BY A BLANK CARD TO GET THE PUCHED CARD
     *         OUT OF THE PUNCH.
     *********************************************************************
     *
     P2        MCW  READ&79,PUNCH&79    *MOVE THE DATA (& = +)
               P                        *PUNCH
     *                                  *CLEAR PUNCH BUFFER AND SET WM
               CS   180                 *CLEAR 180 TO 101
               SW   101                 *SET A WORD MARK AT THE BEGINNING
               P                        *PUNCH A BLANK CARD
               H    P3                  *HALT THEN GO TO P3
     *
     *********************************************************************
     *         THE FOLLOWING CODE WILL MOVE THE CARD DATA FROM THE READ BUFFER
     *         TO THE PRINT BUFFER AND PRINT THE CARD DATA.
     *         THIS WILL BE FOLLOWED BY A FOUR BLANK LINES TO GET THE PRINTED
     *         DATA UP TO BE SEEN.
     *********************************************************************
     *
     P3        MCW  READ&79,PRINT&79    *MOVE THE DATA (& = +)
               W                        *WRITE THE PRINT LINE
     *                                  *CLEAR PUNCH BUFFER AND SET WM
               CS   280                 *CLEAR 280 TO 201
               SW   201                 *SET A WORD MARK AT THE BEGINNING
               W                        *WRITE THE PRINT LINE         
               W                        *WRITE THE PRINT LINE
               W                        *WRITE THE PRINT LINE
               W                        *WRITE THE PRINT LINE
               H    P4                  *HALT THEN GO TO P4
     *
     *********************************************************************
     *         THE FOLLOWING CODE WILL:
     *            1.  INCREMENT A COUNTER
     *            2.  MOVE THE COUNTER TO THE PRINT LINE SUPRESSING ZEROS
     *            3.  lOOP 20 TIMES
     *            4.  PRINT 4 BLANK LINES
     *********************************************************************
     *
     MYCNTR    DCW  0000                *A GENERIC 4 DIGIT FILED STARTING AT 0
     LOOPC     DCW  000                 *A GENERIC 3 DIGIT COUNTER STARTING AT 0
     MYTXT     DCW  @THIS IS LINE NUMBER @  *FILLER TEXT
     *
     P4        MCW  MYTXT,PRINT&22      *MOVE IN THE FILLER TEXT
     P41       A    &1,MYCNTR           *ADD NUMERICAL LITERIAL TO COUNTER
               MCS  MYCNTR,PRINT&25     *MOVE AND SUPPRESS ZERO
               W                        *WRITE A PRINT LINE
               A    &1,LOOPC            *ADD NUMERICAL LITERIAL TO LOOP COUNTER
               B    P42,LOOPC-1,2       *IF YOU HAVE 20, CUT OUT
               B    P41                 *LETS GO BACK AND DO IT AGAIN
     *
     *                                  *PRINT FOUR BLANK LINES
     P42       CS   280                 *CLEAR 280 TO 201
               SW   201                 *SET A WORD MARK AT THE BEGINNING
               W                        *WRITE THE PRINT LINE         
               W                        *WRITE THE PRINT LINE
               W                        *WRITE THE PRINT LINE
               W                        *WRITE THE PRINT LINE
               H    P5                  *HALT THEN GO TO P5 
     *
     *********************************************************************
     *         THE IBM 1401 ALLOWS THE DEFINITION OF A NUMERIC FIELD TO BE
     *         ANY SIZE THAT WILL FIT IN MEMORY. THE HARDWARE PERFORMS 
     *         INTEGER ARITHMATIC. fOR MONEY, THE UNITS ARE PENNEYS.
     *         MYMONEY    DCW    12345  IS 123.45. THE REAL PLACEMENT OF 
     *         THE DECIMAL IS DONE BY THE PROGRAMMER.
     *         WHEN MATH IS PERFORMED, THE ZONE BITS IN THE UNITS POSITION
     *         MAY BE SET ACCORDING TO THE SIGN OF THE FIELD. iF YOU KNOW 
     *         THE FIELD IS POSITIVE AND YOU WANT TO SEE THE VALUE IM MEMORY,
     *         YOU CAN USE THE FOLLING TRICK:
     *                    MZ   MYMONEY-1,MYMONEY
     *         THE SECOND TO LAST CHARACTER IN MYMONEY NEVER HAS ZONE BITS.
     *         BY MOVING THE BLANK ZONE BITS TO THE LAST CHARACTER, 
     *         YOU CLEAR THE SIGN ZONE BITS FOR THE FIELD. 
     *         
     *********************************************************************
     *
     ITEM1     DCW  &1235               *FOR THIS CASE, THIS IS $12.35
     ITEM2     DCW  &050                *FOR THIS CASE, THIS IS $.50
     ACCUM     DCW  000000              *FOR THIS CASE, THIS IS $0,000.00
     *
     P5        H
               A    ITEM1,ACCUM         *ADD IN THE PROFIT
               S    ITEM2,ACCUM         *SUBTRACT THE LOSS
     *
     *         THESE NUMBERS CAN BE SHOWN AS
     *
               MCW  @ITEM1 = @,PRINT&10 *MOVE IN TEXT
               MCW  ITEM1,PRINT&20      *MOVE IN VALUE
               MCW  @ITEM2 = @,PRINT&30 *MOVE IN TEXT
               MCW  ITEM2,PRINT&40      *MOVE IN VALUE
               MCW  @SUMMED = @,PRINT&50 *MOVE IN TEXT
               MCW  ACCUM,PRINT&60      *MOVE IN VALUE
               W                        *PRINT THE LINE
               CS   299                 *CLEAR THE PRINT LINE
     *
     *         THESE NUMBERS CAN BE SHOWN AS USING MOVE AND SUPPRESS ZERO
     *
               MCW  @ITEM1 = @,PRINT&10 *MOVE IN TEXT
               MCS  ITEM1,PRINT&20     *MOVE IN VALUE
               MCW  @ITEM2 = @,PRINT&30 *MOVE IN TEXT
               MCS  ITEM2,PRINT&40      *MOVE IN VALUE
               MCW  @SUMMED = @,PRINT&50 *MOVE IN TEXT
               MCS  ACCUM,PRINT&60      *MOVE IN VALUE
               W                        *PRINT THE LINE
               CS   299                 *CLEAR THE PRINT LINE
     *
     *         THESE NUMBERS CAN BE SHOWN AS USING MOVE AND EDIT
     *
     P53       MCW  @ITEM1 = @,PRINT&10 *MOVE IN TEXT
               MCW  @$00.00@,PRINT&20   *MOVE IN EDIT MASK
               MCE  ITEM1,PRINT&20      *MOVE IN VALUE
               MCW  @ITEM2 = @,PRINT&30 *MOVE IN TEXT
               MCW  @$0.00@,PRINT&40    *MOVE IN EDIT MASK
               MCE  ITEM2,PRINT&40      *MOVE IN VALUE
               MCW  @SUMMED = @,PRINT&50 *MOVE IN TEXT
               MCW  @$  ,  0.00@,PRINT&60 *MOVE IN EDIT MASK
               MCE  ACCUM,PRINT&60      *MOVE IN VALUE
               W                        *PRINT THE LINE
               CS   299                 *CLEAR THE PRINT LINE
               H    P6
     P6        H    P6
               NOP
               END  START
