               JOB  IBM 1401 MUSIC
               CTL  6611  *6=16,000C;6=16,000T;1=OBJDECK;,1=MODADD
     *
     RDBUFF    EQU  1                   * READ BUFFER   (1-80)
     PUBUF1    EQU  102                 * READ BUFFER PLUS 1
     PUBUFF    EQU  101                 * PUNCH BUFFER  (101-181)
     PRBUFF    EQU  201                 * PRINT BUFFER  (201-332)
     ONEAD     DSA  001                 * ONE MORE FOR MA
     TWOAD     DSA  002                 * TWO MORE FOR MA
     *
               ORG  85
               DCW  @X1@
     X1        DCW  000                 * INDEX REGISTER 1
               DC   @X2@
     X2        DCW  000                 * INDEX REGISTER 2
               DC   @X3@
     X3        DCW  0000                * INDEX REGISTER 3
     *
               ORG  350
     *
               DCW  @IBM 1401 MUSIC PROGRAM 01-18-2012@
     *
     ***** PROGRAM CONSTANTS ****************************************
     *   THESE VARABLES ARE TO MAKE THE DIVIDE EASIER TO UNDERSTAND *
     ****************************************************************
     A         DCW  00              * DIVISOR
     BH        DCW  00000           * ANSWER
     BL        DC   0000            * ANSWER
     *
     CARS      DCW  000             * HOW MANY CHARACTERS TO MOVE FOR THIS NOTE
     TIME      DCW  000             * TIME FOR WHOLE NOTE * 10
     OCTNUM    DCW  @024@           * START IN THE THIRD OCTAVE (3*12)
     NTCNT     DCW  @000@           * NOTE COUNTER
     ERRMK     DCW  @ @             * MARKER FOR CARD INPUT ERROR
     NOTEX     DCW  0000            * NUMBER OF NOTES TO PLAY
     *
     NOTE      DCW  @000@           * STORE THE NOTE
     HOLD1     DCW  0               * STORE A CHARACTER
     HOLD2     DCW  00              * STORE 2 CHARACTERS
     NOTEL     DCW  @00@            * NOTE SIZE
     MARK      DCW  @*@             * MARKER FOR ERROR
     LOOPS     DCW  0000            * MOW MANY LOOPS REQUIRED?
     *
     START     H                    * GET READY TO GO
               CS   332             * CLEAR PRINT BUFFER
               CS                   * CLEAR PRINT BUFFER
               CS   180             * CLEAR PUNCH BUFFER
               CS   080             * CLEAR READ BUFFER
     *
     RDCRD     CS   080             * CLEAR READ BUFFFER
               R                    * READ A CARD
               SW   201             * SET A WM FOR MOVE
               MCW  080,280         * MOVE THE CARD IMAGE   
               W                    * PRINT INPUT CARD
               CS   299             * CLEAR PRINT BUFFER
     *
     * SQUEEZE OUT SPACES IN DATA FROM CARD BUFFER TO PUNCH BUFFER
     *
               CS   180                * CLEAR THE PUNCH BUFFER
               MCW  @000@,X1           * INITIALIZE X1 AND X2 AND X3
               MCW  @000@,X2           * INITIALIZE X1 AND X2 AND X3
               MA   @000@,X3           * INITIALIZE X1 AND X2 AND X3
     *
     LOP1      BCE  ASKXT,001&X1,*     * IS IT AN ASTERISK? 
               BCE  BLANK,001&X1,      * IS IT A SPACE?
               SW   001&X1             * SET A WM FOR MOVE
               MCW  001&X1,101&X2      * MOVE IN THE NON-SPACE CHAR
               MA   ONEAD,X2           * INCREMENT X2
     BLANK     MA   ONEAD,X1           * INCREMENT X1
               C    @080@,X1           * SEE IF WE ARE DONE
               BL   LOP1               * DO MORE OF THE CARD
     ASKXT     NOP                     * FOUND AN * SO IGNORE THE REST
     *
     * DONE WITH SQUEEZE
     *
     * ARE WE AT A ONE OF TWO POSSIBLE TERMINUS?
     *
               C    PUBUFF&4,@(EOM)@   * IS IT THE END OF THE DECK?
               BE   PLAY               * LETS GO PLAY
               C    PUBUFF&4,@(EOF)@   * IS IT THE END OF THE DECK?
               BE   EXIT               * LETS GO HOME
               NOP                     * FALL THROUGH
     *
     * NOW WE PROCESS ALL OF THE DATA FOR MUSIC
     *
               MCW  @000@,X1          * INITIALIZE X1
     NXTNT     MCW  @000@,NOTEL       * INITIALIZE NOTEL
               MCW  PUBUFF&X1,HOLD1   * PICK UP THE CHARACTER
               BCE  RDCRD,HOLD1,      * IF WE ARE AT A SPACE
     *                                * WE ARE DONE WITH THIS CARD
               BCE  OCTV,HOLD1,O      * IS IT AN OCTAVE?
               BCE  NOTEA,HOLD1,A     * IS IT AN A NOTE?
               BCE  NOTEB,HOLD1,B     * IS IT AN B NOTE?
               BCE  NOTEC,HOLD1,C     * IS IT AN C NOTE?
               BCE  NOTED,HOLD1,D     * IS IT AN D NOTE?
               BCE  NOTEE,HOLD1,E     * IS IT AN E NOTE?
               BCE  NOTEF,HOLD1,F     * IS IT AN F NOTE?
               BCE  NOTEG,HOLD1,G     * IS IT AN G NOTE?
               BCE  NOTES,HOLD1,S     * IS IT AN S NOTE?
               B    CARDER            * WE HAVE A CARD ERROR
     *
     OCTV      A    @1@,X1            * INCREMENT X1
               MCW  PUBUFF&X1,HOLD1   * PICK U THE CHARACTER
               BCE  OCTV1,HOLD1,1     * IS IT  1?
               BCE  OCTV2,HOLD1,2     * IS IT  2? 
               BCE  OCTV3,HOLD1,3     * IS IT  3?
               BCE  OCTV4,HOLD1,4     * IS IT  4?
               BCE  OCTV5,HOLD1,5     * IS IT  5?
               B    CARDER            * WE HAVE A CARD ERROR
     *
     OCTV1     MCW  @000@,OCTNUM      * SET THE OCTAVE TO 1
               B    OCTVX             * EXIT FUNCTION
     OCTV2     MCW  @012@,OCTNUM      * SET THE OCTAVE TO 2
               B    OCTVX             * EXIT FUNCTION
     OCTV3     MCW  @024@,OCTNUM      * SET THE OCTAVE TO 3
               B    OCTVX             * EXIT FUNCTION
     OCTV4     MCW  @036@,OCTNUM      * SET THE OCTAVE TO 4
               B    OCTVX             * EXIT FUNCTION
     OCTV5     MCW  @048@,OCTNUM      * SET THE OCTAVE TO 5
               B    OCTVX             * EXIT FUNCTION
     OCTVX     MA   ONEAD,X1          * INCREMENT X1
               B    NXTNT             * GO GET NEXT NOTE
     *
     *
     NOTEA     MCW  @001@,NOTE        * SET THE NOTE
               B    CHECK             * CHECK THE MODIFIER
     NOTEB     MCW  @003@,NOTE        * SET THE NOTE
               B    CHECK             * CHECK THE MODIFIER
     NOTEC     MCW  @004@,NOTE        * SET THE NOTE
               B    CHECK             * CHECK THE MODIFIER
     NOTED     MCW  @006@,NOTE        * SET THE NOTE
               B    CHECK             * CHECK THE MODIFIER
     NOTEE     MCW  @008@,NOTE        * SET THE NOTE
               B    CHECK             * CHECK THE MODIFIER
     NOTEF     MCW  @009@,NOTE        * SET THE NOTE
               B    CHECK             * CHECK THE MODIFIER
     NOTEG     MCW  @011@,NOTE        * SET THE NOTE
               B    CHECK             * CHECK THE MODIFIER
     NOTES     MCW  @999@,NOTE        * SET THE NOTE
               B    CKX               * CHECK THE MODIFIER EXIT
     CHECK     MA   ONEAD,X1          * POINT TO NEXT POSITION
               MCW  PUBUFF&X1,HOLD1   * PICK UP NEXT CHARACTER
               BCE  CK1,HOLD1,#       * SHARP?
               BCE  CK1,HOLD1,+       * SHARP?
               BCE  CK1,HOLD1,&       * SHARP?
               BCE  CK2,HOLD1,-       * FLAT?
               B    NOTSZ             * GO GET NOTE SIZE
     CK1       A    @1@,NOTE          * GO UP ONE
               B    CKX               * OUT OF HERE
     CK2       S    @1@,NOTE          * DOWN ONE STEP
               MZ   NOTE-1,NOTE       * CLEAR ZONE
               C    @000@,NOTE        * CHECKING FOR ZERO
               BH   CKX               * BRANCH IF OVER ZERO
               MCW  @001@,NOTE        * SET TO 1
     CKX       MA   ONEAD,X1          * POINT TO NEXT POSITION
               MCW  PUBUFF&X1,HOLD1   * PICK UP THE NEXT CHARACTER
     *
     * THE FOLLOWING CODE DETERMINES THE LENGTH OF THE CURRENT
     * NOTE. A 1 IS A WHOLE NOTE A 4 IS A QUARTER NOTE
     * A 16 IS A 16TH NOTE.
     *
     NOTSZ     C    HOLD1,@Z@         * SEE IF NUMERIC
               BL   GOT1              * FOUND 1 NUMBER
               B    CARDER            * WE HAVE A CARD ERROR
     GOT1      C    PUBUFF&X1&1,@Z@   * SEE IF NEXT IS NUMERIC
               BL   DIG2              * WE HAVE TWO DIGITS
     *   ELSE WE HAVE ONLY ONE DIGIT
     DIG1      MCW  HOLD1,NOTEL       * SET NOTE LENGTH
               MA   ONEAD,X1          * POINT TO NEXT POSITION
               B    STORN             * STORE THE NOTE
     *
     DIG2      MCW  HOLD1,NOTEL-1     * PUT IT IN ITS PLACE
               MCW  PUBUFF&X1&1,HOLD1   * GET FIRST CHARACTER
               MCW  HOLD1,NOTEL       * PUT IT IN ITS PLACE
               MA   TWOAD,X1          * POINT TO NEXT POSITION
               B    STORN             * STORE THE NOTE
     *
     * STORE THE NOTE IN A TABLE TO BE PLAYED LATER
     * VARIABLES AVAILABLE AT THIS POINT ARE 
     *   NOTE   = PLACE IN MUSIC TABLE (TBL)
     *   OCTAVE = OFFSET IN MUSIC TABLE (TBL) DUE TO OCTAVE
     *   NOTEL  = DIVISION OF FULL NOTE
     *               1 = FULL NOTE
     *               2 = HALF NOTE
     *               4 = QUARTER NOTE ETC
     *   
     *
     *                     * 1=WHOLE, 2=HALF, 4=QUARTER
     *
     STORN     ZA   NOTE,A          * PICKUP NOTE VALUE
               A    OCTNUM,A        * ADD THE OCTAVE OFFSET
               S    @1@,A           * CHANGE TO ZERO BASED
     *
               ZA   @0@,BL          * ZERO OUT BH & BL
               MCW  @6@,BH          * 8 CHARTERS PER NOTE ENTRY
               M    A,BL            * MULTIPLY
               MZ   BL-1,BL         * CLEAR ZONE
               MCW  BL-1,X2         * GET THE ANSWER
     *
               MCW  TBL&X2-3,CARS   * PICK UP NUMBER OF CARACTERS
               MCW  TBL&X2,TIME     * PICK UP TIME
     *
               ZA   TIME,BL         * LOAD DIVIDEN
               ZA   NOTEL,A         * LOAD DIVISOR
               D    A,BH            * THE MAGIC DIVIDE
               MCW  BL-3,LOOPS      * STORE THE RESULTS 
               MZ   LOOPS-1,LOOPS   * CLEAR SIGN
               C    LOOPS,@0001@    * HAVE WE GONE TO ZERO?
               BL   OKNUM           * OK, = 2 OR GT 0001
               MCW  @0001@,LOOPS    * THAT FIXES IT
     OKNUM     NOP                  * KEEP CODE CLEAN
     *                              
     *DEBUG
               CS   332
               CS
               MCW  @NOTE @,210
               MCW  NOTE,220
     *
               MCW  @NOTEL@,230
               MCW  NOTEL,240
     *
               MCW  @X1@,250
               MCW  X1,260
     *
               MCW  @CARS @,270
               MCW  CARS,280
     *
               MCW  @TIME@,290
               MCW  TIME,300
     *
               MCW  @LOOPS@,310
               MCW  LOOPS,320
     *
               W                    * PRINT RESULTS
               CS   332             * CLEAR PRINT BUFFER
               CS                   * CLEAR PRINT BUFFER
               LCA  CARS,0&X3   * STORE THE NOTE
               LCA  LOOPS,0&X3   * STORE THE DURATION
               A    @1@,NTCNT       * COUNT THE NOTES STORED
               BCE  NXTNT,NTCNT-2,0  * IF 0 WE HAVE NOT DONE 2 MANY
     *    YOU ONLY GET HERE IF YOU HAVE ENTERED 1000 NOTES TO PLAY
               CS   332             * CLEAR PRINT STORAGE
               CS                   * CLEAR PRINT STORAGE 
               MCW  @ERROR ***** YOU HAVE EXCEEDED THE 1000 NOTE LIMIT@,280
               W                    * PRINT
               CC   1               * PAGE EJECT
               CS   332             * CLEAR PRINT STORAGE
               CS                   * CLEAR PRINT STORAGE 
               W                    * PRINT
               B    EXIT            * GO HOME
     *
     *         DUMMY ENTRY TO LOAD THE MVTBL
     MMMMM     MCW  MVTBL&X1,MVTBL&X1   *JUST TO TAKE UP TIME
     *
     NNNNN     B    PLAY4           * LAST ENTRY IN TABLE
     *
     PLAY      BCE  EXIT,ERRMK,E    * IF YOU HAD AN ERROR, GO HOME
     *
               MCW  MITBL,X1        * SET X1 TO FIRST ENTRY IN THE TABLE
               MCW  @0000@,LOOPS    * ZERO LOOPS
     PLAY2     LCA  MMMMM&6,0&X1    * ADD AN INSTRUCTION
               A    @1@,LOOPS       * ADD 1 TO LOOP COUNT
               BCE  PLAY3,LOOPS-2,5   * HAVE WE HIT 500 YET?
               MA   @007@,X1        * INCREMENT X1
               B    PLAY2           * GO LOOP AGAIN
     *
     PLAY3     MA   @004@,X1          * INCREMENT X1
               LCA  NNNNN&3,0&X1  * ADD A "B   PLAY4" INSTRUCTION
               MA   @004@,X1          * INCREMENT X1
               LCA  NNNNN&3,0&X1  * ADD A "B   PLAY4" INSTRUCTION
     PLAY4     H    *
               H    PLAY
     IMG       B    PLAY4
     CARDER    SW   201
               MCW  180,280
               MCW  @INPUT CARD ERROR@,300
               W
               CS   332
               CS
               MCW  MARK,201&X1
               W
               CS   332
               CS
               W
               MCW  @E@,ERRMK       * NOTE THE ERROR
               B    RDCRD
     *
     **********************************************************
     *         GET READY TO BOOT FROM THE FOLLOWING DECK
     *
     EXIT      CS   332             * CLEAR PRINT STORAGE
               CS                   * CLEAR PRINT STORAGE
               CS                   * CLEAR PUNCH STORAGE
               CS                   * CLEAR READ STORAGE
               SW   001             * SET WORDMARK IN LOCATION 1
     NREAD     R                    * READ FIRST CARD OF NEXT  DECK
               BCE  001,001,,       * IS IT A COMMA? BRANCH TO
     *                              * THE FIRST INSTRUCTION
               B    NREAD           * CHECK THE NEXT ONE
               NOP
     *********************************************************
     * FIVE OCTAVES OF NOTES
     * TWELVE NOTES PER OCTAVE
     * FIRST 3 DIGITS DEFINES THE LENGTH OF EACH MOVE
     * THE LAST 5 DIGITS = THE NUMBER OF MOVES PER WHOLE NOTE
     * XXX.XX
     * THIS IS USED TO DETERMINE HOW MANY
     * MOVES TO PLAY A FULL NOTE OF 256 MS.
     * TO PLAY A FULL "D" NOTE, FIRST OCTAVE,
     * YOU MUST MOVE 701 LOCATIONS 16 TIMES.
     *
     TBL       DCW  @788014@     * A       (1) 14 LOOPS A FULL NOTE
               DCW  @743015@     * A#,A+,B-(2)
               DCW  @701016@     * B,C-    (3)
               DCW  @662017@     * C       (4)
               DCW  @624018@     * C#,C+,D-(5)
               DCW  @589019@     * D       (6)               
               DCW  @556020@     * D#,D+,E-(7)          
               DCW  @525021@     * E       (8)
               DCW  @495022@     * F       (9)                  
               DCW  @467024@     * F#,F+,G-(10)
               DCW  @441025@     * G       (11)
               DCW  @416026@     * G#,G+,A-(12)
               DCW  @392028@     * AND SO ON
               DCW  @370030@
               DCW  @349031@
               DCW  @329033@
               DCW  @311035@
               DCW  @293037@
               DCW  @276040@
               DCW  @261042@
               DCW  @246044@
               DCW  @232047@
               DCW  @219050@
               DCW  @206053@
               DCW  @195056@
               DCW  @184059@
               DCW  @173063@
               DCW  @163066@
               DCW  @154070@
               DCW  @145074@
               DCW  @137079@
               DCW  @129083@
               DCW  @121089@
               DCW  @115093@
               DCW  @108099@
               DCW  @102105@
               DCW  @096111@
               DCW  @090118@
               DCW  @085125@
               DCW  @080132@
               DCW  @075140@
               DCW  @071148@
               DCW  @067156@
               DCW  @063165@
               DCW  @059176@
               DCW  @056185@
               DCW  @052198@
               DCW  @049209@
               DCW  @046222@
               DCW  @044231@
               DCW  @041246@
               DCW  @039258@
               DCW  @036277@
               DCW  @034291@
               DCW  @032308@
               DCW  @030326@
               DCW  @028346@
               DCW  @026369@
               DCW  @025382@
               DCW  @023410@
     SILEN     DCW  @99941046@    *SILENCE ??????
     *
     *   2000 - 5000         * 999 ENTRY TABLE TO HOLD NOTES TO BE PLAYED
     NTTBL     DSA  2002     * FIRST ENTRY IN NOTE TABLE
     *   5000 - 8000         * 999 ENTRY TABLE TO DURATION ENTRIES
     DRTBL     DSA  5002     * FIRST ENTRY IN DURATION TABLE
     *   8000 - 9000         * SPACE FOR CHARACTER MOVES
     MVTBL     DSA  8999     * END OF AREA
     *   9000 -12500         * TABLE OF MOVE INSTRUCTIONS
     MITBL     DSA  9006     * FIRST ENTRY IN TABLE
               ORG  13000     *END OF TABLES
               END  START
