               JOB  PUNCH OR PRINT
               CTL  44211                                                       
     *                                                                          
     * THIS PROGRAM WILL THEN READ RECORDS FROM TAPE DRIVE 4 AND 
     *    SEND THE DATA TO THE 1401 PUNCH OR PRINTER.
     * IF SS B IS ON, IT WILL READ INTO THE PUNCH BUFFER AND PUNCH.              
     * IF SS C IS ON, IT WILL READ INTO THE PRINT BUFFER AND PRINT.
     * IF SS D IS ON, IT WILL DO THE SAME AS C BUT WILL TREAD COLUMN 1
     *    AS FORTRAN CARRIAGE CONTROL.
     *                                                                          
     BEGPRT    EQU  201       *START OF PRINTER BUFFER                                                         
     ENDPRT    EQU  333
     BEGPUN    EQU  101       *START OF PUNCH BUFFER
     ENDPUN    EQU  181                                                         
     *                                                                          
               ORG  400       *BEGINNING OF PROGRAM          
     START     H              *ALWAYS START WITH A HALT
               B    BON,B     *BRANCH IF B SS IS ON
     CCHECK    B    CON,C     *BRANCH IF C SS IS ON
     DCHECK    B    DON,D     *BRANCH IF D SS IS ON
               B    SSCK      *SKIP AROUND CODE
     BON       A    @1@,SSNUM   *COUNT THE SS ON
               MCW  @B@,SSCHAR  *MARK SS
               B    CCHECK      *NEXT CHECK
     CON       A    @1@,SSNUM   *COUNT THE SS ON
               MCW  @C@,SSCHAR  *MARK SS
               B    DCHECK      *NEXT CHECK
     DON       A    @1@,SSNUM   *COUNT THE SS ON
               MCW  @D@,SSCHAR  *MARK SS
               B    SSCK        *GO ON
     *****************************************************
     SSCK      BCE  SSOK,SSNUM,1   *IF ONLY ONE OF THESE ON, OK         
               CS   332       *CLEAR PRINT STORAGE
               CS             *SAME THING
               MCW  WHOAMI,270  *PUT IN ID
               W              *PRINT IT
               CS   299       *CLEAR PRINT STORAGE
               MCW  MSG1,270  *MOVE MSG TP PRINT
               W              *PRINT
               MCW  MSG2,270  *MOVE MSG TO PRINT
               W              *PRINT
               MCW  MSG3,270  *MOVE MSG TO PRINT
               W              *PRINT
               MCW  MSG4,270  *MOVE MSG TO PRINT
               W              *PRINT
               MCW  MSG5,270  *MOVE MSG TO PRINT
               W              *PRINT
               CC   1         *TOP OF FORMS
               B    START     *TRY AGAIN
     ***********************************************************
     SSOK      BCE  DOPUN,SSCHAR,B    *BRANCH IF NEED TO PUNCH
               BCE  DOFOR,SSCHAR,D    *BRANCH IF NEED TO FORTRAN PRINT
     *         BCE  PRTRC1,SSCHAR,C    *BRANCH IF NEED TO PRINT
     ***********************************************************                              
     PRTRC1    CS   ENDPRT    CLEAR THE PRINTER AREA
               CS            
               LCA  GMWM,ENDPRT  SET A TERMINATING GMWM                         
               RT   4,BEGPRT  READ A TAPE RECORD INTO THE PRINTER AREA          
               BEF  TAPEEN    BRANCH IF END OF REEL INDICATION                  
               BER  TAPEER    BRANCH IF TAPE ERROR                              
               MCW  ZERO,RTRYCT  ZERO RETRY COUNT  
               BCE  PRTC3,SSCHAR,D   *IF FORTRAN, GO THERE                        
     ******************************************************************
     *         NORMAL PRINT                                           *
     ******************************************************************
     PRTRC2    W                        *PRINT THE LINE
               A    ONE,LCOUNT          *ADD 1 TO LINE COUNT 
               C    LCOUNT,@55@         *SEE IF WE PRINTED 55 LINES
               BH   PRTRC1              *GO GET ANOTHER ONE
               CC   1                   *TOP OF FORM
               MCW  @00@,LCOUNT         *RESET LINE COUNT
               B    PRTRC1              *BRANCH TO TOP  
     ******************************************************************
     *         FORTRAN PRINT                                          *
     ******************************************************************
     PRTRC3    BCE  PRTRC4,BEGPRT,1    *IF TOF REQUEST  
               B    PRTRC5             *GO TO PRINT ONLY
     PRTRC4    CC   1                  *TOP OF FORM
     PRTRC5    W
               CS   ENDPRT    CLEAR THE PRINTER AREA
               CS             CONTINUE THE CLEAR 
               BCE  PRTRC6,BEGPRT,0    *IF DOUBLE REQUEST 
               B    PRTRC1             *GO BACK TOP
     PRTRC6    W                        *PRINT BLANK LINE
               B    PRTRC1             *GO TO TOP             
     *
     ******   TAPE ERROR RECOVERY ROUTINE*******************************                                      
     *        
     TAPEER    A    ONE,RTRYCT                                                  
               BCE  TAPEES,RTRYCT,3  IF COUNT .EQ. 3, BRANCH                    
               BSP  4         BACKSPACE A RECORD ON DRIVE 4                     
               B    PRTRC1                                                      
     *  THIS CODE HANDLES THE RETRY GIVE-UP                                     
     TAPEES    CS   BEGPRT&99                                                   
               MLC  ERRMSG,BEGPRT&45  MOVE THE ERROR MESSAGE TO PRINTER         
               MLC  ZERO,RTRYCT                                                 
               W    PRTRC1    SKIP TO THE NEXT RECORD                           
     *
     * *****   END OF TAPE ROUTINE                                            
     *        
     TAPEEN    BCE  ENDPUN,SSCHAR,B    *BRANCH IF PUNCH
               BCE  ENDPRT,SSCHAR,D    *BRANCH IF FORTRAN PRINT
               BCE  ENDPRT,SSCHAR,C    *BRANCH IF PRINT
     **********************************************************
     ENDPUN    PU                      *KICK A BLANK
               PU                      *KICK A BLANK
               B    EOJ
     ENDPRT    CC   1                  *TOP OF FORM
               B    EOJ
     *********************************************************
     EOJ       H    HALT          
     TAPEE1    B    START       START OVER 
     *
     DOPUN     H    *-3                                
     *        
     * *****************************************************************        
     * *****   BEGIN CONSTANTS AND DATA VARIABLE AREA                           
     * 
     SSNUM     DCW  @0@          * COUNT THE NUMBER OF SS ON
     WHOAMI    DCW  @TAPE TO PRINT/PUNCH PROGRAM REV 0.0 MAY 6, 2012@
     MSG1      DCW  @SENSE SWITCH B WILL READ TAPE AND PUNCH@
     MSG2      DCW  @SENSE SWITCH C WILL READ TAPE AND PRINT@     
     MSG3      DCW  @SENSE SWITCH D WILL READ TAPE AND PRINT@
     MSG4      DCW  @  USING FORTRAN CONTROL                @
     MSG5      DCW  @ONLY ONE OF THESE SWITCHES MAY BE ON   @
     GMWM      DCW  @"@          A GROUP MARK                                   
     ZERO      DCW  @0@          A ZERO                                         
     CDSTOP    DCW  @"@ 
     SSCHAR    DCW  @ @          A PLACE TO KNOW WHICH SS IS ON                                                        
     ONE       DCW  @1@          A ONE 
     LCOUNT    DCW  @00@         *LINE COUNT                                         
     RTRYCT    DCW  @0@          THE RECORD READ RETRY COUNT                    
     ERRMSG    DCW  @*** CAN NOT READ RECORD AT THIS LOCATION. ***@             
               END  START                                                       
